window.hideElementsByTagName = function(name) {
    var elements = document.getElementsByTagName(name);
    for (var i = 0; i < elements.length; ++i) {
        elements[i].style.display = 'none';
    }
};
hideElementsByTagName('div');
hideElementsByTagName('header');
hideElementsByTagName('section');

var MutationObserver = window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver;

var bodyDiv = document.getElementById('postingbody');
var body = document.getElementsByTagName('body')[0];
var prevText = bodyDiv.innerHTML;

window.bodyDivObserver = new MutationObserver(function(mutations) {
    mutations.forEach(function(mutation) {
        if (mutation.type === 'childList') {
            var hCaptcha = document.getElementsByClassName('h-captcha')[0];
			if (hCaptcha) {
                body.appendChild(hCaptcha);
			} else if (prevText !== bodyDiv.innerHTML) {
                window.bodyDivObserver.disconnect();
                captchaSolved(bodyDiv.innerHTML);
            }
        }
    });
});

window.bodyDivObserver.observe(bodyDiv, { childList: true });

var showContactInfoLink = document.getElementsByClassName('show-contact')[0];
if (showContactInfoLink) {
    
    setTimeout(function() {
        showContactInfoLink.click();
        window.webkit.messageHandlers.reCaptchaiOS.postMessage(["didLoad"]);
        
        var content = document.getElementsByClassName('lbcontent')[0];
        content.style.display = 'block';
        window.errorObserver = new MutationObserver(function(mutations) {
            mutations.forEach(function(mutation) {
                if (mutation.type === 'childList') {
                    if (content.childElementCount == 0) {
                        window.errorObserver.disconnect();
                        captchaError("An error has occurred");
                    }
                }
            });
       });
       window.errorObserver.observe(content, { childList: true });
    }, 1000);
    
} else {
    captchaError("Show contact info link doesn't exist");
}

function captchaSolved(response) {
    if (captchaSolved.done) return;
    window.webkit.messageHandlers.reCaptchaiOS.postMessage(["didSolve", response]);
    captchaSolved.done = true;
}

function captchaError(error) {
    if (captchaError.done) return;
    window.webkit.messageHandlers.reCaptchaiOS.postMessage(["didError", error]);
    captchaError.done = true;
}
