window.hideElementsByTagName = function (name) {
    var elements = document.getElementsByTagName(name);
    for (var i = 0; i < elements.length; ++i) {
        elements[i].style.display = 'none';
    }
};
hideElementsByTagName('div');
hideElementsByTagName('header');
hideElementsByTagName('section');

var MutationObserver = window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver;

var actionsComboDiv = document.getElementsByClassName('actions-combo')[0];
var replyInfoPopup = document.getElementsByClassName('reply-info js-only')[0];
var body = document.getElementsByTagName('body')[0];

window.replyInfoObserver = new MutationObserver(function (mutations) {
    mutations.forEach(function (mutation) {
        if ('none' !== replyInfoPopup.style.display) {
            var phoneButton = document.getElementsByClassName('show-phone')[0];
            var emailButton = document.getElementsByClassName('show-email')[0];
            if (phoneButton) {
                phoneButton.click();
            } else if (emailButton) {
                emailButton.click();
            } else {
                captchaSolved(document.documentElement.innerHTML);
            }
        }
    });
});

window.actionsComboDivObserver = new MutationObserver(function (mutations) {
    mutations.forEach(function (mutation) {
        var hCaptcha = document.getElementsByClassName('h-captcha')[0];
        if (hCaptcha) {
            body.appendChild(hCaptcha);
            window.actionsComboDivObserver.disconnect();
        }
    });
});

window.actionsComboDivObserver.observe(actionsComboDiv, {childList: true});
window.replyInfoObserver.observe(replyInfoPopup, {attributes: true, childList: true, subtree: true});

var replyButton = document.getElementsByClassName('reply-button js-only')[0];
if (replyButton) {
    setTimeout(function tick() {
        var captcha = document.getElementsByClassName('h-captcha')[0];
        if (!captcha) {
            replyButton.click();
            setTimeout(tick, 1000);
        }
    }, 1000);

    setTimeout(function () {
        window.webkit.messageHandlers.reCaptchaiOS.postMessage(["didLoad"]);

        var content = document.getElementsByClassName('lbcontent')[0];
        if (content) {
            content.style.display = 'block';
            window.errorObserver = new MutationObserver(function (mutations) {
                mutations.forEach(function (mutation) {
                    if (mutation.type === 'childList') {
                        if (content.childElementCount == 0) {
                            window.errorObserver.disconnect();
                            captchaError("An error has occurred");
                        }
                    }
                });
            });
            window.errorObserver.observe(content, {childList: true});
        }
    }, 1000);

} else {
    captchaError("Reply button doesn't exist");
}

function captchaSolved(response) {
    if (captchaSolved.done) return;
    window.webkit.messageHandlers.reCaptchaiOS.postMessage(["didSolve", response]);
    captchaSolved.done = true;
}

function captchaError(error) {
    if (captchaError.done) return;
    window.webkit.messageHandlers.reCaptchaiOS.postMessage(["didError", error]);
    captchaError.done = true;
}
